# coding: utf-8

"""
    FreeClimb API

    FreeClimb is a cloud-based application programming interface (API) that puts the power of the Vail platform in your hands. FreeClimb simplifies the process of creating applications that can use a full range of telephony features without requiring specialized or on-site telephony equipment. Using the FreeClimb REST API to write applications is easy! You have the option to use the language of your choice or hit the API directly. Your application can execute a command by issuing a RESTful request to the FreeClimb API. The base URL to send HTTP requests to the FreeClimb REST API is: /apiserver. FreeClimb authenticates and processes your request.

    The version of the OpenAPI document: 1.0.0
    Contact: support@freeclimb.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import StrictStr
from typing import Optional, Set
from typing_extensions import Self


class ConferenceParticipantResult(
    BaseModel, populate_by_name=True, validate_assignment=True, protected_namespaces=()
):
    """
    ConferenceParticipantResult
    """  # noqa: E501

    uri: Optional[StrictStr] = Field(
        default=None, description="The URI for this resource, relative to /apiserver."
    )
    date_created: Optional[StrictStr] = Field(
        default=None,
        description="The date that this resource was created (GMT) in RFC 1123 format (e.g., Mon, 15 Jun 2009 20:45:30 GMT).",
        alias="dateCreated",
    )
    date_updated: Optional[StrictStr] = Field(
        default=None,
        description="The date that this resource was last updated (GMT) in RFC 1123 format (e.g., Mon, 15 Jun 2009 20:45:30 GMT).",
        alias="dateUpdated",
    )
    revision: Optional[StrictInt] = Field(
        default=None,
        description="Revision count for the resource. This count is set to 1 on creation and is incremented every time it is updated.",
    )
    account_id: Optional[StrictStr] = Field(
        default=None,
        description="ID of the account that created this participant.",
        alias="accountId",
    )
    conference_id: Optional[StrictStr] = Field(
        default=None,
        description="ID of the conference this participant is in.",
        alias="conferenceId",
    )
    call_id: Optional[StrictStr] = Field(
        default=None,
        description="ID of the Call associated with this Participant.",
        alias="callId",
    )
    talk: Optional[StrictBool] = Field(
        default=None,
        description="True if this Participant has talk privileges in the Conference. False otherwise.",
    )
    listen: Optional[StrictBool] = Field(
        default=None,
        description="True if this Participant has listen privileges in the Conference. False otherwise.",
    )
    dtmf_pass_through: Optional[StrictBool] = Field(
        default=None,
        description="True if this Participant had dtmfPassThrough privileges in the Conference. False otherwise.",
        alias="dtmfPassThrough",
    )
    start_conf_on_enter: Optional[StrictBool] = Field(
        default=None,
        description="True if this Participant joining the Conference caused the Conference to start (status = inProgress). False otherwise.",
        alias="startConfOnEnter",
    )

    __properties: ClassVar[List[str]] = [
        "uri",
        "dateCreated",
        "dateUpdated",
        "revision",
        "accountId",
        "conferenceId",
        "callId",
        "talk",
        "listen",
        "dtmfPassThrough",
        "startConfOnEnter",
    ]

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConferenceParticipantResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if account_id (nullable) is None
        # and model_fields_set contains the field
        if self.account_id is None and "account_id" in self.model_fields_set:
            _dict["accountId"] = None

        # set to None if conference_id (nullable) is None
        # and model_fields_set contains the field
        if self.conference_id is None and "conference_id" in self.model_fields_set:
            _dict["conferenceId"] = None

        # set to None if call_id (nullable) is None
        # and model_fields_set contains the field
        if self.call_id is None and "call_id" in self.model_fields_set:
            _dict["callId"] = None

        # set to None if talk (nullable) is None
        # and model_fields_set contains the field
        if self.talk is None and "talk" in self.model_fields_set:
            _dict["talk"] = None

        # set to None if listen (nullable) is None
        # and model_fields_set contains the field
        if self.listen is None and "listen" in self.model_fields_set:
            _dict["listen"] = None

        # set to None if dtmf_pass_through (nullable) is None
        # and model_fields_set contains the field
        if (
            self.dtmf_pass_through is None
            and "dtmf_pass_through" in self.model_fields_set
        ):
            _dict["dtmfPassThrough"] = None

        # set to None if start_conf_on_enter (nullable) is None
        # and model_fields_set contains the field
        if (
            self.start_conf_on_enter is None
            and "start_conf_on_enter" in self.model_fields_set
        ):
            _dict["startConfOnEnter"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConferenceParticipantResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "uri": obj.get("uri"),
                "dateCreated": obj.get("dateCreated"),
                "dateUpdated": obj.get("dateUpdated"),
                "revision": obj.get("revision"),
                "accountId": obj.get("accountId"),
                "conferenceId": obj.get("conferenceId"),
                "callId": obj.get("callId"),
                "talk": obj.get("talk"),
                "listen": obj.get("listen"),
                "dtmfPassThrough": obj.get("dtmfPassThrough"),
                "startConfOnEnter": obj.get("startConfOnEnter"),
            }
        )
        return _obj
